import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { UserAddress, UserAddressParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询收货地址
 */
export async function pageUserAddress(params: UserAddressParam) {
  const res = await request.get<ApiResult<PageResult<UserAddress>>>(
    MODULES_API_URL + '/shop/user-address/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询收货地址列表
 */
export async function listUserAddress(params?: UserAddressParam) {
  const res = await request.get<ApiResult<UserAddress[]>>(
    MODULES_API_URL + '/shop/user-address',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加收货地址
 */
export async function addUserAddress(data: UserAddress) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-address',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改收货地址
 */
export async function updateUserAddress(data: UserAddress) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-address',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除收货地址
 */
export async function removeUserAddress(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-address/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除收货地址
 */
export async function removeBatchUserAddress(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/user-address/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询收货地址
 */
export async function getUserAddress(id: number) {
  const res = await request.get<ApiResult<UserAddress>>(
    MODULES_API_URL + '/shop/user-address/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
